%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%if 0%{?fedora}
# There are some missing deps
%global with_python3 0
%endif

%global pypi_name os-brick

Name:           python-%{pypi_name}
Version:        1.6.1
Release:        6%{?dist}
Provides:        python2-os-brick = %{version}-%{release}
Summary:        OpenStack Cinder brick library for managing local volume attaches

License:        ASL 2.0
URL:            http://www.openstack.org/
Source0:        https://tarballs.openstack.org/%{pypi_name}/%{pypi_name}-%{version}.tar.gz

# patches_base=+2
Patch0001: 0001-Close-connection-to-ceph-after-cinder-bakcup.patch
Patch0002: 0002-RBD-enclose-ipv6-addresses-in-square-brackets.patch
Patch0003: 0003-Fix-cmd-execution-stderr-stdout-unicode-errors.patch
Patch0004: 0004-encryptors-Mock-os_brick.executor-correctly.patch
Patch0005: 0005-encryptors-Workaround-mangled-passphrases.patch
Patch0006: 0006-Fix-iSCSI-multipath-rescan.patch
Patch0007: 0007-Refactor-iSCSI-disconnect.patch
Patch0008: 0008-Refactor-iSCSI-connect.patch
Patch0009: 0009-Add-open-iscsi-manual-scan-support.patch
Patch0010: 0010-Fix-iSCSI-cleanup-issue-when-using-discovery.patch
Patch0011: 0011-iSCSI-multipath-improve-logging-on-connect.patch
Patch0012: 0012-Fix-manual-scan-for-discovery-type-backends.patch
Patch0013: 0013-Fix-iSCSI-cleanup-fix-on-discovery-backends.patch
Patch0014: 0014-Return-symlinks-for-encrypted-volumes.patch
Patch0015: 0015-Return-WWN-in-multipath_id.patch
Patch0016: 0016-Don-t-obscure-logs-on-iSCSI-sendtargets-failure.patch
Patch0017: 0017-Get-the-right-portal-from-output-of-iscsiadm-command.patch
Patch0018: 0018-Fix-ISCSIConnector._get_potential_volume_paths-logic.patch
Patch0019: 0019-Fix-iSCSI-volume-attachment-over-RDMA-transport.patch

BuildArch:      noarch

Provides:       os-brick = %{version}-%{release}
Requires:       python-babel >= 2.3.4
Requires:       python-castellan >= 0.4.0
Requires:       python-eventlet >= 0.17.4
Requires:       python-oslo-serialization >= 1.10.0
Requires:       python-oslo-concurrency >= 3.8.0
Requires:       python-oslo-i18n >= 2.1.0
Requires:       python-oslo-log >= 1.14.0
Requires:       python-oslo-service >= 1.10.0
Requires:       python-oslo-utils >= 3.16.0
Requires:       python-requests >= 2.5.2
Requires:       python-retrying
Requires:       python-six >= 1.9.0
Requires:       python-oslo-privsep >= 1.9.0
Requires:       python-os-win
BuildRequires:  python2-devel
BuildRequires:  python-ddt
BuildRequires:  python-pbr >= 1.6.0
BuildRequires:  python-reno
BuildRequires:  python-sphinx
BuildRequires:  python-oslo-concurrency  >= 3.8.0
BuildRequires:  python-oslo-i18n >= 2.1.0
BuildRequires:  python-oslo-log >= 1.14.0
BuildRequires:  python-oslo-service >= 1.10.0
BuildRequires:  python-oslo-sphinx >= 2.5.0
BuildRequires:  python-requests >= 2.5.2
BuildRequires:  python-six >= 1.9.0
BuildRequires:  python-setuptools
BuildRequires:  python-oslo-privsep >= 1.9.0
%description
OpenStack Cinder brick library for managing local volume attaches

%if 0%{?with_python3}
%package -n python3-%{pypi_name}
Summary:        OpenStack Cinder brick library for managing local volume attaches
%{?python_provide:%python_provide python3-%{pypi_name}}

Requires:       python3-babel >= 2.3.4
Requires:       python3-castellan >= 0.4.0
Requires:       python3-eventlet >= 0.17.4
Requires:       python3-oslo-serialization >= 1.10.0
Requires:       python3-oslo-concurrency >= 3.8.0
Requires:       python3-oslo-i18n >= 2.1.0
Requires:       python3-oslo-log >= 1.14.0
Requires:       python3-oslo-service >= 1.10.0
Requires:       python3-oslo-utils >= 3.16.0
Requires:       python3-requests >= 2.5.2
Requires:       python3-retrying
Requires:       python3-six >= 1.9.0
Requires:       python3-oslo-privsep >= 1.5.0
Requires:       python3-os-win

BuildRequires:  python3-devel
BuildRequires:  python3-ddt
BuildRequires:  python3-pbr >= 1.6.0
BuildRequires:  python3-reno
BuildRequires:  python3-sphinx
BuildRequires:  python3-oslo-concurrency  >= 3.8.0
BuildRequires:  python3-oslo-i18n >= 2.1.0
BuildRequires:  python3-oslo-log >= 1.14.0
BuildRequires:  python3-oslo-service >= 1.10.0
BuildRequires:  python3-oslo-sphinx >= 2.5.0
BuildRequires:  python3-requests >= 2.5.2
BuildRequires:  python3-six >= 1.9.0
BuildRequires:  python3-setuptools
BuildRequires:  python3-oslo-privsep >= 1.5.0

%description -n python3-%{pypi_name}
OpenStack Cinder brick library for managing local volume attaches

%endif

%prep
%setup -q -n %{pypi_name}-%{upstream_version}

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1

%build
CFLAGS="%{optflags}" %{__python} setup.py %{?py_setup_args} build --executable="%{__python2} -s"
%if 0%{?with_python3}
%py3_build
%endif

%install
CFLAGS="%{optflags}" %{__python} setup.py %{?py_setup_args} install -O1 --skip-build --root %{buildroot}
# generate html docs
sphinx-build doc/source html
# remove the sphinx-build leftovers
rm -rf html/.{doctrees,buildinfo}

%if 0%{?with_python3}
%py3_install
%endif

# Move config files to proper location
install -d -m 755 %{buildroot}%{_datarootdir}/%{pypi_name}/rootwrap
mv %{buildroot}/usr/etc/os-brick/rootwrap.d/*.filters %{buildroot}%{_datarootdir}/%{pypi_name}/rootwrap

%files -n python-%{pypi_name}
%license LICENSE
%doc html README.rst
%{python2_sitelib}/os_brick*
%{_datarootdir}/%{pypi_name}

%if 0%{?with_python3}
%files -n python3-%{pypi_name}
%license LICENSE
%doc html README.rst
%{python3_sitelib}/os_brick*
%{_datarootdir}/%{pypi_name}
%endif

%changelog
* Fri Aug 25 2017 Gorka Eguileor <geguileo@redhat.com> 1.6.1-6
- Fix iSCSI volume attachment over RDMA transport (RHBZ#1484496)

* Tue Aug 15 2017 Eric Harney <eharney@redhat.com> 1.6.1-5
- Refactor iSCSI to increase reliability (RHBZ #1441066)

* Wed Feb 08 2017 Eric Harney <eharney@redhat.com> 1.6.1-4
- Fix cmd execution unicode errors (RHBZ #1387677)
- Volume encryption: Workaround mangled passphrases (RHBZ #1387677)

* Fri Nov 11 2016 Eric Harney <eharney@redhat.com> 1.6.1-3
- Fix Ceph IPv6 address parsing (RHBZ #1390013)

* Fri Oct 14 2016 Eric Harney <eharney@redhat.com> 1.6.1-2
- Fix Ceph connection leak in cinder-backup (RHBZ #1384604)

* Wed Sep 14 2016 Haikel Guemar <hguemar@fedoraproject.org> 1.6.1-1
- Update to 1.6.1

